package com.memorynotfound;

import javax.el.ELContext;
import javax.faces.application.Application;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.RequestScoped;
import javax.faces.context.FacesContext;

@ManagedBean
@RequestScoped
public class UserBean {

    public ProfileBean getManagedBeanByEvaluateExpressionGet(){
        FacesContext context = FacesContext.getCurrentInstance();
        Application application = context.getApplication();
        return application.evaluateExpressionGet(context, "#{profileBean}", ProfileBean.class);
    }

    public ProfileBean getManagedBeanByValueExpression(){
        FacesContext context = FacesContext.getCurrentInstance();
        Application application = context.getApplication();
        ELContext elContext = context.getELContext();
        return  (ProfileBean) application.getExpressionFactory()
                .createValueExpression(elContext, "#{profileBean}", ProfileBean.class).getValue(elContext);
    }

    public ProfileBean getManagedBeanByElResolver(){
        FacesContext context = FacesContext.getCurrentInstance();
        ELContext elContext = context.getELContext();
        return (ProfileBean) elContext.getELResolver().getValue(elContext, null, "profileBean");
    }

}
